/*
 * AddDocumentDialog.java
 *
 * Created on 16-mar-2011, 14:22:38
 */
package scimat.gui.components.adddialog;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.add.AddAuthorEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;

/**
 *
 * @author mjcobo
 */
public class AddAuthorDialog extends javax.swing.JDialog {

  /** Creates new form AddDocumentDialog */
  public AddAuthorDialog(java.awt.Frame parent) {
    super(parent, true);
    initComponents();
  }

  /**
   *
   */
  public void refresh() {

    this.authorNameTextField.setText("");
    this.fullAuthorNameTextField.setText("");
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    addButton = new javax.swing.JButton();
    cancelButton = new javax.swing.JButton();
    jSeparator1 = new javax.swing.JSeparator();
    authorNameDescriptionLabel = new javax.swing.JLabel();
    authorNameTextField = new javax.swing.JTextField();
    fullAuthorNameTextField = new javax.swing.JTextField();
    fullAuthorNameDescriptionLabel = new javax.swing.JLabel();

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    setTitle("Add document");
    setAlwaysOnTop(true);
    setModal(true);

    addButton.setText("Add");
    addButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addButtonActionPerformed(evt);
      }
    });

    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        cancelButtonActionPerformed(evt);
      }
    });

    authorNameDescriptionLabel.setText("Name:");

    fullAuthorNameDescriptionLabel.setText("Full author name:");

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
              .addComponent(jSeparator1, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
              .addGroup(layout.createSequentialGroup()
                .addComponent(addButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cancelButton)))
            .addContainerGap())
          .addGroup(layout.createSequentialGroup()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
              .addComponent(authorNameDescriptionLabel)
              .addComponent(fullAuthorNameDescriptionLabel))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
              .addComponent(authorNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE)
              .addComponent(fullAuthorNameTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE))
            .addContainerGap())))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(authorNameDescriptionLabel)
          .addComponent(authorNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(fullAuthorNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(fullAuthorNameDescriptionLabel))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(cancelButton)
          .addComponent(addButton))
        .addContainerGap())
    );

    pack();
  }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt
   */
  private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
    dispose();
  }//GEN-LAST:event_cancelButtonActionPerformed

  /**
   * 
   * @param evt
   */
  private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.authorNameTextField.getText().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a name.\nPlease, " +
        "give a name for the author.", "Invalid author name", JOptionPane.ERROR_MESSAGE);

    } else if (this.fullAuthorNameTextField.getText().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a full name.\nPlease, " +
        "give a full name for the author.", "Invalid full author name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new AddAuthorEdit(this.authorNameTextField.getText(),
              this.fullAuthorNameTextField.getText()), rootPane);

      task.execute();

      if (task.isSuccessful()) {

        dispose();
      }
    }
  }//GEN-LAST:event_addButtonActionPerformed
  
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addButton;
  private javax.swing.JLabel authorNameDescriptionLabel;
  private javax.swing.JTextField authorNameTextField;
  private javax.swing.JButton cancelButton;
  private javax.swing.JLabel fullAuthorNameDescriptionLabel;
  private javax.swing.JTextField fullAuthorNameTextField;
  private javax.swing.JSeparator jSeparator1;
  // End of variables declaration//GEN-END:variables
}
