/*
 * AnalysisViewDialog.java
 *
 * Created on 05-abr-2011, 0:01:47
 */
package scimat.gui.components.analysisview;

import scimat.analysis.CurrentAnalysis;
import scimat.gui.commands.task.MakeAdvancedReportHTMLTask;
import scimat.gui.commands.task.MakeAdvancedReportLaTeXTask;
import scimat.gui.commands.task.MakeReportHTMLTask;
import scimat.gui.commands.task.MakeReportLaTeXTask;

/**
 *
 * @author mjcobo
 */
public class AnalysisViewDialog extends javax.swing.JDialog {

  /** Creates new form AnalysisViewDialog */
  public AnalysisViewDialog(java.awt.Frame parent, boolean modal) {
    super(parent, modal);
    initComponents();
  }

  /**
   * 
   */
  public void refresh() {

    this.longitudinalResultPanel.refresh();
    this.resultsByPeriodPanel.refresh();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        mainTabbedPane = new javax.swing.JTabbedPane();
        longitudinalResultPanel = new scimat.gui.components.analysisview.LongitudinalResultPanel();
        resultsByPeriodPanel = new scimat.gui.components.analysisview.ResultsByPeriodPanel();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        exportHTMLMenuItem = new javax.swing.JMenuItem();
        exportToFullHTMLMenuItem = new javax.swing.JMenuItem();
        exportLatexMenuItem = new javax.swing.JMenuItem();
        exportToFullLaTexMenuItem = new javax.swing.JMenuItem();
        separator = new javax.swing.JPopupMenu.Separator();
        exitMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("SciMAT 1.1 - Analysis view");

        mainTabbedPane.addTab("Longitudinal view", longitudinalResultPanel);
        mainTabbedPane.addTab("Period view", resultsByPeriodPanel);

        fileMenu.setText("File");

        exportHTMLMenuItem.setText("Export to HTML");
        exportHTMLMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportHTMLMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exportHTMLMenuItem);

        exportToFullHTMLMenuItem.setText("Export to HTML (full)");
        exportToFullHTMLMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportToFullHTMLMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exportToFullHTMLMenuItem);

        exportLatexMenuItem.setText("Export to LaTeX");
        exportLatexMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportLatexMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exportLatexMenuItem);

        exportToFullLaTexMenuItem.setText("Export to LaTeX (full)");
        exportToFullLaTexMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportToFullLaTexMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exportToFullLaTexMenuItem);
        fileMenu.add(separator);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainTabbedPane)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainTabbedPane, javax.swing.GroupLayout.DEFAULT_SIZE, 678, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt 
   */
  private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
    dispose();
  }//GEN-LAST:event_exitMenuItemActionPerformed

  /**
   * 
   * @param evt 
   */
  private void exportHTMLMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportHTMLMenuItemActionPerformed
   (new MakeReportHTMLTask(rootPane, CurrentAnalysis.getInstance().getResults())).execute();
  }//GEN-LAST:event_exportHTMLMenuItemActionPerformed

  /**
   * 
   * @param evt 
   */
  private void exportLatexMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportLatexMenuItemActionPerformed
    (new MakeReportLaTeXTask(rootPane, CurrentAnalysis.getInstance().getResults())).execute();
  }//GEN-LAST:event_exportLatexMenuItemActionPerformed

  /**
   * 
   */
  private void exportToFullHTMLMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportToFullHTMLMenuItemActionPerformed
    (new MakeAdvancedReportHTMLTask(rootPane, CurrentAnalysis.getInstance().getResults())).execute();
  }//GEN-LAST:event_exportToFullHTMLMenuItemActionPerformed

  private void exportToFullLaTexMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportToFullLaTexMenuItemActionPerformed
    (new MakeAdvancedReportLaTeXTask(rootPane, CurrentAnalysis.getInstance().getResults())).execute();
  }//GEN-LAST:event_exportToFullLaTexMenuItemActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenuItem exportHTMLMenuItem;
    private javax.swing.JMenuItem exportLatexMenuItem;
    private javax.swing.JMenuItem exportToFullHTMLMenuItem;
    private javax.swing.JMenuItem exportToFullLaTexMenuItem;
    private javax.swing.JMenu fileMenu;
    private scimat.gui.components.analysisview.LongitudinalResultPanel longitudinalResultPanel;
    private javax.swing.JTabbedPane mainTabbedPane;
    private javax.swing.JMenuBar menuBar;
    private scimat.gui.components.analysisview.ResultsByPeriodPanel resultsByPeriodPanel;
    private javax.swing.JPopupMenu.Separator separator;
    // End of variables declaration//GEN-END:variables
}
