/*
 * OverlappingMapPanel.java
 *
 * Created on 10-may-2011, 12:30:41
 */
package scimat.gui.components.analysisview;

import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import org.apache.batik.swing.JSVGCanvas;
import org.apache.batik.swing.JSVGScrollPane;
import org.w3c.dom.Document;
import scimat.api.analysis.temporal.OverlappingMap;
import scimat.api.visualization.temporal.OverlappingMapSVG;

/**
 *
 * @author mjcobo
 */
public class OverlappingMapPanel extends javax.swing.JPanel {

  /** Creates new form OverlappingMapPanel */
  public OverlappingMapPanel() {

      this.svgCanvas = new JSVGCanvas();
      this.svgScrollPane = new JSVGScrollPane(svgCanvas);
      this.overlappingMapSVG = new OverlappingMapSVG(40, 80, 40, 10);

      initComponents();

      this.addComponentListener(new ComponentAdapter() {

        @Override
        public void componentResized(ComponentEvent e) {

          svgCanvas.setDocument(document);
        }
      });

      this.svgCanvas.setDocumentState(JSVGCanvas.ALWAYS_DYNAMIC);

      add(this.svgScrollPane);
  }

  /**
   * 
   * @param strategicDiagram
   */
  public void refreshItems(OverlappingMap overlappingMap) {

    this.document = this.overlappingMapSVG.buildXML(overlappingMap);
    
    this.svgCanvas.setDocument(document);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    setLayout(new javax.swing.BoxLayout(this, javax.swing.BoxLayout.LINE_AXIS));
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables
  private JSVGCanvas svgCanvas;
  private JSVGScrollPane svgScrollPane;
  private Document document;
  private OverlappingMapSVG overlappingMapSVG;
}
