/*
 * WordDetailPanel.java
 *
 * Created on 28-ene-2009, 10:42:51
 */
package scimat.gui.components.detailspanel;

import java.util.ArrayList;
import scimat.model.knowledgebase.entity.Affiliation;
import scimat.model.knowledgebase.exception.KnowledgeBaseException;
import scimat.project.CurrentProject;

/**
 *
 * @author Manuel Jesús Cobo Martin
 */
public class AffiliationDetailPanel extends GenericDetailPanel<Affiliation> {

  /** 
   * Creates new form WordDetailPanel
   */
  public AffiliationDetailPanel() {
    initComponents();

    CurrentProject.getInstance().getKbObserver().addAffiliationObserver(this);
  }

  /**
   *
   */
  public void reset() {

    idTextField.setText("");
    fullAffiliationTextField.setText("");

    setEnableTextField(false);
  }

  /**
   *
   */
  public void setEnableTextField(boolean enabled) {

    idTextField.setEnabled(enabled);
    fullAffiliationTextField.setEnabled(enabled);
  }

  /**
   * 
   * @param affiliation
   */
  public void refreshItem(Affiliation affiliation) {

    this.affiliation = affiliation;

    if (this.affiliation != null) {

      idTextField.setText(this.affiliation.getAffiliationID().toString());
      fullAffiliationTextField.setText(this.affiliation.getFullAffiliation());
      
      setEnableTextField(true);

    } else {

      reset();

    }
  }

  /**
   * 
   * @return
   */
  public String getFullAffiliation() {

    return fullAffiliationTextField.getText();
  }

  /**
   *
   * @param items
   * @throws KnowledgeBaseException
   */
  public void entityAdded(ArrayList<Affiliation> items) throws KnowledgeBaseException {
    // Do Nothing
  }

  /**
   * 
   * @param items
   * @throws KnowledgeBaseException
   */
  public void entityRemoved(ArrayList<Affiliation> items) throws KnowledgeBaseException {
    // Do Nothing
  }

  /**
   *
   * @param entity
   * @throws KnowledgeBaseException
   */
  public void entityRefresh() throws KnowledgeBaseException {
    // Do Nothing
  }

  /**
   * 
   * @param items
   * @throws KnowledgeBaseException
   */
  public void entityUpdated(ArrayList<Affiliation> items) throws KnowledgeBaseException {

    int position;

    position = items.indexOf(this.affiliation);

    if (position != -1) {

      refreshItem(items.get(position));

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    idDescriptionLabel = new javax.swing.JLabel();
    idTextField = new javax.swing.JTextField();
    fullAffiliationDescriptionLabel = new javax.swing.JLabel();
    fullAffiliationTextField = new javax.swing.JTextField();

    idDescriptionLabel.setText("ID:");

    idTextField.setEnabled(false);

    fullAffiliationDescriptionLabel.setText("Full affiliation:");

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(idDescriptionLabel)
          .addComponent(fullAffiliationDescriptionLabel))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(layout.createSequentialGroup()
            .addComponent(idTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap())
          .addComponent(fullAffiliationTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(idDescriptionLabel)
          .addComponent(idTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(fullAffiliationDescriptionLabel)
          .addComponent(fullAffiliationTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel fullAffiliationDescriptionLabel;
  private javax.swing.JTextField fullAffiliationTextField;
  private javax.swing.JLabel idDescriptionLabel;
  private javax.swing.JTextField idTextField;
  // End of variables declaration//GEN-END:variables
  private Affiliation affiliation = null;
}
