/*
 * JournalDetailPanel.java
 *
 * Created on 19 de noviembre de 2008, 18:34
 */
package scimat.gui.components.detailspanel;

import java.util.ArrayList;
import scimat.model.knowledgebase.entity.ReferenceSource;
import scimat.model.knowledgebase.exception.KnowledgeBaseException;
import scimat.project.CurrentProject;

/**
 *
 * @author  Manuel Jesus Cobo Martin.
 */
public class ReferenceSourceDetailPanel extends GenericDetailPanel<ReferenceSource> {

  /** 
   * Creates new form JournalDetailPanel 
   */
  public ReferenceSourceDetailPanel() {
    initComponents();

    CurrentProject.getInstance().getKbObserver().addReferenceSourceObserver(this);
  }
  
  /**
   * 
   */
  public void reset() {

    idTextField.setText("");
    sourceTextField.setText("");

    setEnableTextField(false);
  }

  /**
   *
   */
  public void setEnableTextField(boolean enabled) {

    idTextField.setEnabled(enabled);
    sourceTextField.setEnabled(enabled);
  }

  /**
   *
   * @param referenceSource
   */
  public void refreshItem(ReferenceSource referenceSource) {

    this.referenceSource = referenceSource;

    if (referenceSource != null) {

      idTextField.setText(this.referenceSource.getReferenceSourceID().toString());
      sourceTextField.setText(this.referenceSource.getSource());

      setEnableTextField(true);

    } else {

      reset();

    }
  }

  /**
   * 
   * @param editable
   */
  public void setEditable(boolean editable) {
  
    sourceTextField.setEditable(editable);
  }

  /**
   * 
   * @return
   */
  public String getSource() {

    return sourceTextField.getText();
  }

  public void entityAdded(ArrayList<ReferenceSource> items) throws KnowledgeBaseException {
    // Do Nothing
  }

  public void entityRefresh() throws KnowledgeBaseException {
    // Do Nothing
  }

  public void entityUpdated(ArrayList<ReferenceSource> items) throws KnowledgeBaseException {

    int position;

    position = items.indexOf(this.referenceSource);

    if (position != -1) {

      refreshItem(items.get(position));

    }
  }

  public void entityRemoved(ArrayList<ReferenceSource> items) throws KnowledgeBaseException {
    // Do Nothing
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    idDescriptionLabel = new javax.swing.JLabel();
    idTextField = new javax.swing.JTextField();
    sourceDescriptionLabel = new javax.swing.JLabel();
    sourceTextField = new javax.swing.JTextField();

    idDescriptionLabel.setText("ID:");

    idTextField.setEditable(false);

    sourceDescriptionLabel.setText("Source:");

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(idDescriptionLabel)
          .addComponent(sourceDescriptionLabel))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(sourceTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 185, Short.MAX_VALUE)
          .addComponent(idTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addGap(0, 0, 0))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(idDescriptionLabel)
          .addComponent(idTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(sourceDescriptionLabel)
          .addComponent(sourceTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel idDescriptionLabel;
  private javax.swing.JTextField idTextField;
  private javax.swing.JLabel sourceDescriptionLabel;
  private javax.swing.JTextField sourceTextField;
  // End of variables declaration//GEN-END:variables
  private ReferenceSource referenceSource;
}
