/*
 * GlobalReplaceAffiliationPanel.java
 *
 * Created on 22-ene-2012, 17:52:08
 */
package scimat.gui.components.globalreplace;

import scimat.gui.commands.edit.globalreplace.GlobalReplacePublishDatesEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;

/**
 *
 * @author mjcobo
 */
public class GlobalReplacePublishDatePanel extends GlobalReplaceSelectFieldsPanel {

  /** Creates new form GlobalReplaceAffiliationPanel */
  public GlobalReplacePublishDatePanel() {
    initComponents();
  }

  /**
   * 
   */
  @Override
  public void fireIncorrectDataObservers() {
    
    if (this.fieldsSelected > 0) {

      notifyIncorrectDataObservers(true, "");

    } else {

      notifyIncorrectDataObservers(false, "A set of fields must be selected");
    }
  }

  /**
   * 
   * @param find
   * @param replace 
   */
  @Override
  public void doGlobalReplaceAction(String find, String replace) {
    
    new PerformKnowledgeBaseEditTask(new GlobalReplacePublishDatesEdit(find, 
            replace, 
            this.yearCheckBox.isSelected(), 
            this.dateCheckBox.isSelected()), this).execute();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        yearCheckBox = new javax.swing.JCheckBox();
        dateCheckBox = new javax.swing.JCheckBox();

        yearCheckBox.setText("Year");
        yearCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                yearCheckBoxActionPerformed(evt);
            }
        });

        dateCheckBox.setText("Date");
        dateCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dateCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(yearCheckBox)
                    .addComponent(dateCheckBox))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(yearCheckBox)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(dateCheckBox)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt 
   */
  private void yearCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_yearCheckBoxActionPerformed
    
    if (this.yearCheckBox.isSelected()) {

      this.fieldsSelected ++;

    } else {

      this.fieldsSelected --;
    }

    fireIncorrectDataObservers();
  }//GEN-LAST:event_yearCheckBoxActionPerformed

  /**
   * 
   * @param evt 
   */
  private void dateCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dateCheckBoxActionPerformed
    
    if (this.dateCheckBox.isSelected()) {

      this.fieldsSelected ++;

    } else {

      this.fieldsSelected --;
    }

    fireIncorrectDataObservers();
  }//GEN-LAST:event_dateCheckBoxActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox dateCheckBox;
    private javax.swing.JCheckBox yearCheckBox;
    // End of variables declaration//GEN-END:variables
  private int fieldsSelected = 0;
}
