/*
 * GlobalReplaceAffiliationPanel.java
 *
 * Created on 22-ene-2012, 17:52:08
 */
package scimat.gui.components.globalreplace;

import scimat.gui.commands.edit.globalreplace.GlobalReplaceReferenceSourcesEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;

/**
 *
 * @author mjcobo
 */
public class GlobalReplaceReferenceSourcePanel extends GlobalReplaceSelectFieldsPanel {

  /** Creates new form GlobalReplaceAffiliationPanel */
  public GlobalReplaceReferenceSourcePanel() {
    initComponents();
  }

  /**
   * 
   */
  @Override
  public void fireIncorrectDataObservers() {
    
    if (this.fieldsSelected > 0) {

      notifyIncorrectDataObservers(true, "");

    } else {

      notifyIncorrectDataObservers(false, "A set of fields must be selected");
    }
  }

  /**
   * 
   * @param find
   * @param replace 
   */
  @Override
  public void doGlobalReplaceAction(String find, String replace) {
    
    new PerformKnowledgeBaseEditTask(new GlobalReplaceReferenceSourcesEdit(find, 
            replace, 
            this.sourceCheckBox.isSelected()), this).execute();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        sourceCheckBox = new javax.swing.JCheckBox();

        sourceCheckBox.setText("Source");
        sourceCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sourceCheckBoxActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(sourceCheckBox)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(sourceCheckBox)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt 
   */
  private void sourceCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sourceCheckBoxActionPerformed
    
    if (this.sourceCheckBox.isSelected()) {

      this.fieldsSelected ++;

    } else {

      this.fieldsSelected --;
    }

    fireIncorrectDataObservers();
  }//GEN-LAST:event_sourceCheckBoxActionPerformed

  /**
   * 
   * @param evt 
   */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox sourceCheckBox;
    // End of variables declaration//GEN-END:variables
  private int fieldsSelected = 0;
}
