/*
 * AuthorGroupGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:11:17
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateAuthorGroupEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.AuthorGroup;

/**
 *
 * @author mjcobo
 */
public class AuthorGroupGlobalSlavePanel extends GlobalSlavePanel<AuthorGroup> {

  /** Creates new form AuthorGroupGlobalSlavePanel */
  public AuthorGroupGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(AuthorGroup item) {

    setMasterItem(item);

    this.authorGroupDetailPanel.refreshItem(item);
    this.authorGroupSlaveAuthorsPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateAuthorGroupButton.setEnabled(true);

    } else {
      
      this.updateAuthorGroupButton.setEnabled(false);

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowAuthorGroupPanel = new scimat.gui.components.HideAndShowPanel();
    authorGroupInfoPanel = new javax.swing.JPanel();
    authorGroupDetailPanel = new scimat.gui.components.detailspanel.AuthorGroupDetailPanel();
    updateAuthorGroupButton = new javax.swing.JButton();
    hideAndShowAuthorPanel = new scimat.gui.components.HideAndShowPanel();
    authorInfoPanel = new javax.swing.JPanel();
    authorGroupSlaveAuthorsPanel = new scimat.gui.components.slavepanel.AuthorGroupSlaveAuthorsPanel();

    this.hideAndShowAuthorGroupPanel.setDescription("Author group info");
    this.hideAndShowAuthorGroupPanel.setPanel(this.authorGroupInfoPanel);

    updateAuthorGroupButton.setText("Update");
    updateAuthorGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateAuthorGroupButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout authorGroupInfoPanelLayout = new javax.swing.GroupLayout(authorGroupInfoPanel);
    authorGroupInfoPanel.setLayout(authorGroupInfoPanelLayout);
    authorGroupInfoPanelLayout.setHorizontalGroup(
      authorGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorGroupInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateAuthorGroupButton))
      .addComponent(authorGroupDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorGroupInfoPanelLayout.setVerticalGroup(
      authorGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(authorGroupDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateAuthorGroupButton))
    );

    this.hideAndShowAuthorPanel.setDescription("Authors info");
    this.hideAndShowAuthorPanel.setPanel(this.authorInfoPanel);

    javax.swing.GroupLayout authorInfoPanelLayout = new javax.swing.GroupLayout(authorInfoPanel);
    authorInfoPanel.setLayout(authorInfoPanelLayout);
    authorInfoPanelLayout.setHorizontalGroup(
      authorInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorGroupSlaveAuthorsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    authorInfoPanelLayout.setVerticalGroup(
      authorInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorGroupSlaveAuthorsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(authorInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorGroupInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorGroupPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowAuthorGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateAuthorGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAuthorGroupButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.authorGroupDetailPanel.getGroupName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a group name.\nPlease, " +
        "give a name for the group.", "Invalid group name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateAuthorGroupEdit(getMasterItem().getAuthorGroupID(),
              this.authorGroupDetailPanel.getGroupName(),
              this.authorGroupDetailPanel.isStopGroup()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateAuthorGroupButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private scimat.gui.components.detailspanel.AuthorGroupDetailPanel authorGroupDetailPanel;
  private javax.swing.JPanel authorGroupInfoPanel;
  private scimat.gui.components.slavepanel.AuthorGroupSlaveAuthorsPanel authorGroupSlaveAuthorsPanel;
  private javax.swing.JPanel authorInfoPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorPanel;
  private javax.swing.JButton updateAuthorGroupButton;
  // End of variables declaration//GEN-END:variables
}
