/*
 * AuthorReferenceGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:12:31
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateAuthorReferenceEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.AuthorReference;

/**
 *
 * @author mjcobo
 */
public class AuthorReferenceGlobalSlavePanel extends GlobalSlavePanel<AuthorReference> {

  /** Creates new form AuthorReferenceGlobalSlavePanel */
  public AuthorReferenceGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(AuthorReference item) {

    setMasterItem(item);

    this.authorReferenceDetailPanel.refreshItem(item);
    this.authorReferenceSlaveAuthorPanel.setMasterItem(item);
    this.authorReferenceSlaveAuthorReferenceGroupPanel.setMasterItem(item);
    this.authorReferenceSlaveReferencesPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateAuthorReferenceButton.setEnabled(true);

    } else {
      
      this.updateAuthorReferenceButton.setEnabled(false);
    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowAuthorReferencePanel = new scimat.gui.components.HideAndShowPanel();
    authorReferenceInfoPanel = new javax.swing.JPanel();
    authorReferenceDetailPanel = new scimat.gui.components.detailspanel.AuthorReferenceDetailPanel();
    updateAuthorReferenceButton = new javax.swing.JButton();
    hideAndShowAuthorReferenceGroupPanel = new scimat.gui.components.HideAndShowPanel();
    authorReferenceGroupInfoPanel = new javax.swing.JPanel();
    authorReferenceSlaveAuthorReferenceGroupPanel = new scimat.gui.components.slavepanel.AuthorReferenceSlaveAuthorReferenceGroupPanel();
    hideAndShowAuthorPanel = new scimat.gui.components.HideAndShowPanel();
    authorInfoPanel = new javax.swing.JPanel();
    authorReferenceSlaveAuthorPanel = new scimat.gui.components.slavepanel.AuthorReferenceSlaveAuthorPanel();
    hideAndShowReferencePanel = new scimat.gui.components.HideAndShowPanel();
    referenceInfoPanel = new javax.swing.JPanel();
    authorReferenceSlaveReferencesPanel = new scimat.gui.components.slavepanel.AuthorReferenceSlaveReferencesPanel();

    this.hideAndShowAuthorReferencePanel.setDescription("Authors-reference info");
    this.hideAndShowAuthorReferencePanel.setPanel(this.authorReferenceInfoPanel);

    updateAuthorReferenceButton.setText("Update");
    updateAuthorReferenceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateAuthorReferenceButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout authorReferenceInfoPanelLayout = new javax.swing.GroupLayout(authorReferenceInfoPanel);
    authorReferenceInfoPanel.setLayout(authorReferenceInfoPanelLayout);
    authorReferenceInfoPanelLayout.setHorizontalGroup(
      authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorReferenceInfoPanelLayout.createSequentialGroup()
        .addContainerGap(324, Short.MAX_VALUE)
        .addComponent(updateAuthorReferenceButton))
      .addComponent(authorReferenceDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
    );
    authorReferenceInfoPanelLayout.setVerticalGroup(
      authorReferenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorReferenceInfoPanelLayout.createSequentialGroup()
        .addComponent(authorReferenceDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateAuthorReferenceButton))
    );

    this.hideAndShowAuthorReferenceGroupPanel.setDescription("Authors-reference group info");
    this.hideAndShowAuthorReferenceGroupPanel.setPanel(this.authorReferenceGroupInfoPanel);

    javax.swing.GroupLayout authorReferenceGroupInfoPanelLayout = new javax.swing.GroupLayout(authorReferenceGroupInfoPanel);
    authorReferenceGroupInfoPanel.setLayout(authorReferenceGroupInfoPanelLayout);
    authorReferenceGroupInfoPanelLayout.setHorizontalGroup(
      authorReferenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorReferenceSlaveAuthorReferenceGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
    );
    authorReferenceGroupInfoPanelLayout.setVerticalGroup(
      authorReferenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(authorReferenceGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(authorReferenceSlaveAuthorReferenceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(21, Short.MAX_VALUE))
    );

    this.hideAndShowAuthorPanel.setDescription("Author reference group info");
    this.hideAndShowAuthorPanel.setPanel(this.authorInfoPanel);

    javax.swing.GroupLayout authorInfoPanelLayout = new javax.swing.GroupLayout(authorInfoPanel);
    authorInfoPanel.setLayout(authorInfoPanelLayout);
    authorInfoPanelLayout.setHorizontalGroup(
      authorInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorReferenceSlaveAuthorPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
    );
    authorInfoPanelLayout.setVerticalGroup(
      authorInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(authorInfoPanelLayout.createSequentialGroup()
        .addComponent(authorReferenceSlaveAuthorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addContainerGap(27, Short.MAX_VALUE))
    );

    this.hideAndShowReferencePanel.setDescription("Reference info");
    this.hideAndShowReferencePanel.setPanel(this.referenceInfoPanel);

    javax.swing.GroupLayout referenceInfoPanelLayout = new javax.swing.GroupLayout(referenceInfoPanel);
    referenceInfoPanel.setLayout(referenceInfoPanelLayout);
    referenceInfoPanelLayout.setHorizontalGroup(
      referenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(authorReferenceSlaveReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
    );
    referenceInfoPanelLayout.setVerticalGroup(
      referenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(referenceInfoPanelLayout.createSequentialGroup()
        .addComponent(authorReferenceSlaveReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
          .addComponent(referenceInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorReferenceGroupInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorReferenceInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorReferencePanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorReferenceGroupPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
          .addComponent(authorInfoPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE)
          .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 391, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowAuthorReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorReferenceInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorReferenceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorReferenceGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateAuthorReferenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAuthorReferenceButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.authorReferenceDetailPanel.getAuthorName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a name.\nPlease, " +
        "give a name for the author reference.", "Invalid author reference name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateAuthorReferenceEdit(getMasterItem().getAuthorReferenceID(),
              this.authorReferenceDetailPanel.getAuthorName()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateAuthorReferenceButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel authorInfoPanel;
  private scimat.gui.components.detailspanel.AuthorReferenceDetailPanel authorReferenceDetailPanel;
  private javax.swing.JPanel authorReferenceGroupInfoPanel;
  private javax.swing.JPanel authorReferenceInfoPanel;
  private scimat.gui.components.slavepanel.AuthorReferenceSlaveAuthorPanel authorReferenceSlaveAuthorPanel;
  private scimat.gui.components.slavepanel.AuthorReferenceSlaveAuthorReferenceGroupPanel authorReferenceSlaveAuthorReferenceGroupPanel;
  private scimat.gui.components.slavepanel.AuthorReferenceSlaveReferencesPanel authorReferenceSlaveReferencesPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorReferenceGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorReferencePanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferencePanel;
  private javax.swing.JPanel referenceInfoPanel;
  private javax.swing.JButton updateAuthorReferenceButton;
  // End of variables declaration//GEN-END:variables
}
