/*
 * DocumentGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 16:01:22
 */
package scimat.gui.components.globalslavepanel;

import java.util.ArrayList;
import java.util.TreeSet;
import scimat.gui.commands.edit.delete.DeleteAffiliationsFromDocumentEdit;
import scimat.gui.commands.edit.delete.DeleteAuthorsFromDocumentEdit;
import scimat.gui.commands.edit.delete.DeleteJournalFromDocumentEdit;
import scimat.gui.commands.edit.delete.DeletePublishDateFromDocumentEdit;
import scimat.gui.commands.edit.delete.DeleteReferencesFromDocumentEdit;
import scimat.gui.commands.edit.delete.DeleteWordsFromDocumentEdit;
import scimat.gui.commands.edit.update.UpdateDocumentEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.gui.components.ErrorDialogManager;
import scimat.gui.components.SelectionObserverButton;
import scimat.gui.components.adddialog.AddDialogManager;
import scimat.gui.components.editdialog.EditDialogManager;
import scimat.model.knowledgebase.dao.AffiliationDAO;
import scimat.model.knowledgebase.dao.AuthorDAO;
import scimat.model.knowledgebase.dao.DocumentDAO;
import scimat.model.knowledgebase.dao.JournalDAO;
import scimat.model.knowledgebase.dao.PublishDateDAO;
import scimat.model.knowledgebase.dao.ReferenceDAO;
import scimat.model.knowledgebase.dao.WordDAO;
import scimat.model.knowledgebase.entity.Affiliation;
import scimat.model.knowledgebase.entity.Author;
import scimat.model.knowledgebase.entity.Document;
import scimat.model.knowledgebase.entity.Journal;
import scimat.model.knowledgebase.entity.PublishDate;
import scimat.model.knowledgebase.entity.Reference;
import scimat.model.knowledgebase.entity.Word;
import scimat.model.knowledgebase.exception.KnowledgeBaseException;
import scimat.project.CurrentProject;

/**
 *
 * @author mjcobo
 */
public class DocumentGlobalSlavePanel extends GlobalSlavePanel<Document> {

  /** Creates new form DocumentGlobalSlavePanel */
  public DocumentGlobalSlavePanel() {
    initComponents();
  }

  /**
   * 
   * @param masterItem
   */
  public void refresh(Document masterItem) {

    boolean flag;
    
    setMasterItem(masterItem);

    this.documentDetailPanel.refreshItem(masterItem);
    this.documentSlaveJournalPanel.setMasterItem(masterItem);
    this.documentSlavePublishDatePanel.setMasterItem(masterItem);
    this.documentSlaveAffiliationsPanel.setMasterItem(masterItem);
    this.documentSlaveAuthorsPanel.setMasterItem(masterItem);
    this.documentSlaveWordsPanel.setMasterItem(masterItem);
    this.documentSlaveReferencesPanel.setMasterItem(masterItem);

    flag = masterItem != null;
    
    this.updateDocumentButton.setEnabled(flag);
    this.addAffiliationButton.setEnabled(flag);
    this.addAuthorButton.setEnabled(flag);
    this.addJournalButton.setEnabled(flag);
    this.addPublishDateButton.setEnabled(flag);
    this.addReferenceButton.setEnabled(flag);
    this.addWordButton.setEnabled(flag);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowDocumentPanel = new scimat.gui.components.HideAndShowPanel();
    documentInfoPanel = new javax.swing.JPanel();
    documentDetailPanel = new scimat.gui.components.detailspanel.DocumentDetailPanel();
    updateDocumentButton = new javax.swing.JButton();
    hideAndShowJournalPanel = new scimat.gui.components.HideAndShowPanel();
    journalInfoPanel = new javax.swing.JPanel();
    documentSlaveJournalPanel = new scimat.gui.components.slavepanel.DocumentSlaveJournalPanel();
    addJournalButton = new javax.swing.JButton();
    deleteJournalButton = new scimat.gui.components.SlaveItemObserverButton();
    hideAndShowPublishDatePanel = new scimat.gui.components.HideAndShowPanel();
    publishDateInfoPanel = new javax.swing.JPanel();
    documentSlavePublishDatePanel = new scimat.gui.components.slavepanel.DocumentSlavePublishDatePanel();
    addPublishDateButton = new javax.swing.JButton();
    deletePublishDateButton = new scimat.gui.components.SlaveItemObserverButton();
    hideAndShowAffiliationPanel = new scimat.gui.components.HideAndShowPanel();
    affiliationsInfoPanel = new javax.swing.JPanel();
    documentSlaveAffiliationsPanel = new scimat.gui.components.slavepanel.DocumentSlaveAffiliationsPanel();
    addAffiliationButton = new javax.swing.JButton();
    deleteAffiliationsButton = new SelectionObserverButton(1,-1);
    this.documentSlaveAffiliationsPanel.addSelectionObserver(this.deleteAffiliationsButton);
    hideAndShowAuthorPanel = new scimat.gui.components.HideAndShowPanel();
    authorsInfoPanel = new javax.swing.JPanel();
    documentSlaveAuthorsPanel = new scimat.gui.components.slavepanel.DocumentSlaveAuthorsPanel();
    addAuthorButton = new javax.swing.JButton();
    deleteAuthorsButton = new SelectionObserverButton(1,-1);
    this.documentSlaveAuthorsPanel.addSelectionObserver(this.deleteAuthorsButton);
    updateAuthorPositionButton = new SelectionObserverButton(1,1);
    this.documentSlaveAuthorsPanel.addSelectionObserver(this.updateAuthorPositionButton);
    hideAndShowWordPanel = new scimat.gui.components.HideAndShowPanel();
    wordsInfoPanel = new javax.swing.JPanel();
    documentSlaveWordsPanel = new scimat.gui.components.slavepanel.DocumentSlaveWordsPanel();
    addWordButton = new javax.swing.JButton();
    deleteWordsButton = new SelectionObserverButton(1,-1);
    this.documentSlaveWordsPanel.addSelectionObserver(this.deleteWordsButton);
    updateWordRolButton = new SelectionObserverButton(1,1);
    this.documentSlaveWordsPanel.addSelectionObserver(this.updateWordRolButton);
    hideAndShowReferencePanel = new scimat.gui.components.HideAndShowPanel();
    referencesInfoPanel = new javax.swing.JPanel();
    documentSlaveReferencesPanel = new scimat.gui.components.slavepanel.DocumentSlaveReferencesPanel();
    addReferenceButton = new javax.swing.JButton();
    deleteReferencesButton = new SelectionObserverButton(1,-1);
    this.documentSlaveReferencesPanel.addSelectionObserver(this.deleteReferencesButton);

    this.hideAndShowDocumentPanel.setDescription("Document info");
    this.hideAndShowDocumentPanel.setPanel(this.documentInfoPanel);

    updateDocumentButton.setText("Update");
    updateDocumentButton.setEnabled(false);
    updateDocumentButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateDocumentButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout documentInfoPanelLayout = new javax.swing.GroupLayout(documentInfoPanel);
    documentInfoPanel.setLayout(documentInfoPanelLayout);
    documentInfoPanelLayout.setHorizontalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(documentDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, documentInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(updateDocumentButton))
    );
    documentInfoPanelLayout.setVerticalGroup(
      documentInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(documentInfoPanelLayout.createSequentialGroup()
        .addComponent(documentDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 315, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(updateDocumentButton))
    );

    this.hideAndShowJournalPanel.setDescription("Journal info");
    this.hideAndShowJournalPanel.setPanel(this.journalInfoPanel);

    addJournalButton.setText("Set");
    addJournalButton.setEnabled(false);
    addJournalButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addJournalButtonActionPerformed(evt);
      }
    });

    deleteJournalButton.setText("Delete");
    deleteJournalButton.setEnabled(false);
    this.documentSlaveJournalPanel.addSlaveItemObserver(this.deleteJournalButton);
    deleteJournalButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteJournalButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout journalInfoPanelLayout = new javax.swing.GroupLayout(journalInfoPanel);
    journalInfoPanel.setLayout(journalInfoPanelLayout);
    journalInfoPanelLayout.setHorizontalGroup(
      journalInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(documentSlaveJournalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, journalInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(addJournalButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deleteJournalButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
    );
    journalInfoPanelLayout.setVerticalGroup(
      journalInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(journalInfoPanelLayout.createSequentialGroup()
        .addComponent(documentSlaveJournalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(journalInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(addJournalButton)
          .addComponent(deleteJournalButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );

    this.hideAndShowPublishDatePanel.setDescription("Publish date info");
    this.hideAndShowPublishDatePanel.setPanel(publishDateInfoPanel);

    addPublishDateButton.setText("Set");
    addPublishDateButton.setEnabled(false);
    addPublishDateButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addPublishDateButtonActionPerformed(evt);
      }
    });

    deletePublishDateButton.setText("Delete");
    deletePublishDateButton.setEnabled(false);
    this.documentSlavePublishDatePanel.addSlaveItemObserver(this.deletePublishDateButton);
    deletePublishDateButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deletePublishDateButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout publishDateInfoPanelLayout = new javax.swing.GroupLayout(publishDateInfoPanel);
    publishDateInfoPanel.setLayout(publishDateInfoPanelLayout);
    publishDateInfoPanelLayout.setHorizontalGroup(
      publishDateInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(documentSlavePublishDatePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, publishDateInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(addPublishDateButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deletePublishDateButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
    );
    publishDateInfoPanelLayout.setVerticalGroup(
      publishDateInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(publishDateInfoPanelLayout.createSequentialGroup()
        .addComponent(documentSlavePublishDatePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addGroup(publishDateInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(deletePublishDateButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(addPublishDateButton)))
    );

    this.hideAndShowAffiliationPanel.setDescription("Affiliation info");
    this.hideAndShowAffiliationPanel.setPanel(this.affiliationsInfoPanel);

    addAffiliationButton.setText("Add");
    addAffiliationButton.setEnabled(false);
    addAffiliationButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addAffiliationButtonActionPerformed(evt);
      }
    });

    deleteAffiliationsButton.setText("Delete");
    deleteAffiliationsButton.setEnabled(false);
    deleteAffiliationsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteAffiliationsButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout affiliationsInfoPanelLayout = new javax.swing.GroupLayout(affiliationsInfoPanel);
    affiliationsInfoPanel.setLayout(affiliationsInfoPanelLayout);
    affiliationsInfoPanelLayout.setHorizontalGroup(
      affiliationsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, affiliationsInfoPanelLayout.createSequentialGroup()
        .addContainerGap(300, Short.MAX_VALUE)
        .addComponent(addAffiliationButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deleteAffiliationsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
      .addComponent(documentSlaveAffiliationsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
    );
    affiliationsInfoPanelLayout.setVerticalGroup(
      affiliationsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, affiliationsInfoPanelLayout.createSequentialGroup()
        .addComponent(documentSlaveAffiliationsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 122, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(affiliationsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(addAffiliationButton)
          .addComponent(deleteAffiliationsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );

    this.hideAndShowAuthorPanel.setDescription("Authors info");
    this.hideAndShowAuthorPanel.setPanel(this.authorsInfoPanel);

    addAuthorButton.setText("Add");
    addAuthorButton.setEnabled(false);
    addAuthorButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addAuthorButtonActionPerformed(evt);
      }
    });

    deleteAuthorsButton.setText("Delete");
    deleteAuthorsButton.setEnabled(false);
    deleteAuthorsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteAuthorsButtonActionPerformed(evt);
      }
    });

    updateAuthorPositionButton.setText("Update position");
    updateAuthorPositionButton.setEnabled(false);
    updateAuthorPositionButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateAuthorPositionButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout authorsInfoPanelLayout = new javax.swing.GroupLayout(authorsInfoPanel);
    authorsInfoPanel.setLayout(authorsInfoPanelLayout);
    authorsInfoPanelLayout.setHorizontalGroup(
      authorsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorsInfoPanelLayout.createSequentialGroup()
        .addContainerGap(189, Short.MAX_VALUE)
        .addComponent(addAuthorButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(updateAuthorPositionButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(4, 4, 4)
        .addComponent(deleteAuthorsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
      .addComponent(documentSlaveAuthorsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
    );
    authorsInfoPanelLayout.setVerticalGroup(
      authorsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, authorsInfoPanelLayout.createSequentialGroup()
        .addComponent(documentSlaveAuthorsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(authorsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(deleteAuthorsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(updateAuthorPositionButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(addAuthorButton)))
    );

    this.hideAndShowWordPanel.setDescription("Words info");
    this.hideAndShowWordPanel.setPanel(this.wordsInfoPanel);

    addWordButton.setText("Add");
    addWordButton.setEnabled(false);
    addWordButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addWordButtonActionPerformed(evt);
      }
    });

    deleteWordsButton.setText("Delete");
    deleteWordsButton.setEnabled(false);
    deleteWordsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteWordsButtonActionPerformed(evt);
      }
    });

    updateWordRolButton.setText("Update rol");
    updateWordRolButton.setEnabled(false);
    updateWordRolButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateWordRolButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout wordsInfoPanelLayout = new javax.swing.GroupLayout(wordsInfoPanel);
    wordsInfoPanel.setLayout(wordsInfoPanelLayout);
    wordsInfoPanelLayout.setHorizontalGroup(
      wordsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, wordsInfoPanelLayout.createSequentialGroup()
        .addContainerGap(211, Short.MAX_VALUE)
        .addComponent(addWordButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(updateWordRolButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deleteWordsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
      .addComponent(documentSlaveWordsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
    );
    wordsInfoPanelLayout.setVerticalGroup(
      wordsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, wordsInfoPanelLayout.createSequentialGroup()
        .addComponent(documentSlaveWordsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 123, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(wordsInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(deleteWordsButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(updateWordRolButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
          .addComponent(addWordButton)))
    );

    this.hideAndShowReferencePanel.setDescription("Reference info");
    this.hideAndShowReferencePanel.setPanel(this.referencesInfoPanel);

    addReferenceButton.setText("Add");
    addReferenceButton.setEnabled(false);
    addReferenceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        addReferenceButtonActionPerformed(evt);
      }
    });

    deleteReferencesButton.setText("Delete");
    deleteReferencesButton.setEnabled(false);
    deleteReferencesButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        deleteReferencesButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout referencesInfoPanelLayout = new javax.swing.GroupLayout(referencesInfoPanel);
    referencesInfoPanel.setLayout(referencesInfoPanelLayout);
    referencesInfoPanelLayout.setHorizontalGroup(
      referencesInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(documentSlaveReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referencesInfoPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addComponent(addReferenceButton)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(deleteReferencesButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
    );
    referencesInfoPanelLayout.setVerticalGroup(
      referencesInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referencesInfoPanelLayout.createSequentialGroup()
        .addComponent(documentSlaveReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 128, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addGroup(referencesInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(addReferenceButton)
          .addComponent(deleteReferencesButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(journalInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
          .addComponent(documentInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowJournalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
          .addComponent(referencesInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(wordsInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(authorsInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(publishDateInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowPublishDatePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
          .addComponent(hideAndShowAffiliationPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
          .addComponent(affiliationsInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
          .addComponent(hideAndShowWordPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE)
          .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 420, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowDocumentPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(documentInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowJournalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(journalInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowPublishDatePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(publishDateInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAffiliationPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(affiliationsInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowAuthorPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(authorsInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowWordPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(wordsInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referencesInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
    );
  }// </editor-fold>//GEN-END:initComponents

  private void updateDocumentButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateDocumentButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    task = new PerformKnowledgeBaseEditTask(new UpdateDocumentEdit(getMasterItem().getDocumentID(),
            this.documentDetailPanel.getTitle(),
            this.documentDetailPanel.getAbstract(), this.documentDetailPanel.getType(),
            this.documentDetailPanel.getCitations(),
            this.documentDetailPanel.getDoi(),
            this.documentDetailPanel.getSourceIdentifier(),
            this.documentDetailPanel.getVolume(),
            this.documentDetailPanel.getIssue(),
            this.documentDetailPanel.getBeginPage(),
            this.documentDetailPanel.getEndPage()), this);

    task.execute();
  }//GEN-LAST:event_updateDocumentButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addWordButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addWordButtonActionPerformed
    
    try {
    
      DocumentDAO documentDAO = CurrentProject.getInstance().getFactoryDAO().getDocumentDAO();
      WordDAO wordDAO = CurrentProject.getInstance().getFactoryDAO().getWordDAO();
      
      ArrayList<Word> wordsInDocument = documentDAO.getWords(getMasterItem().getDocumentID(), false, false, false);
      TreeSet<Word> possibleWords = new TreeSet<Word>(wordDAO.getWords());
      
      possibleWords.removeAll(wordsInDocument);
      
      AddDialogManager.getInstance().showAddWordsToDocumentDialog(getMasterItem(), new ArrayList<Word>(possibleWords));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addWordButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addAffiliationButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAffiliationButtonActionPerformed
    
    try {
    
      DocumentDAO documentDAO = CurrentProject.getInstance().getFactoryDAO().getDocumentDAO();
      AffiliationDAO affiliationDAO = CurrentProject.getInstance().getFactoryDAO().getAffiliationDAO();
      
      ArrayList<Affiliation> affiliationsInDocument = documentDAO.getAffiliations(getMasterItem().getDocumentID());
      TreeSet<Affiliation> possibleAffiliations = new TreeSet<Affiliation>(affiliationDAO.getAffiliations());
      
      possibleAffiliations.removeAll(affiliationsInDocument);
      
      AddDialogManager.getInstance().showAddAffiliationsToDocumentDialog(getMasterItem(), new ArrayList<Affiliation>(possibleAffiliations));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addAffiliationButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addReferenceButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addReferenceButtonActionPerformed
    
    try {
    
      DocumentDAO documentDAO = CurrentProject.getInstance().getFactoryDAO().getDocumentDAO();
      ReferenceDAO referenceDAO = CurrentProject.getInstance().getFactoryDAO().getReferenceDAO();
      
      ArrayList<Reference> referencesInDocument = documentDAO.getReferences(getMasterItem().getDocumentID());
      TreeSet<Reference> referenceWords = new TreeSet<Reference>(referenceDAO.getReferences());
      
      referenceWords.removeAll(referencesInDocument);
      
      AddDialogManager.getInstance().showAddReferencesToDocumentDialog(getMasterItem(), new ArrayList<Reference>(referenceWords));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addReferenceButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteAuthorsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAuthorsButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new DeleteAuthorsFromDocumentEdit(this.getMasterItem(),
              this.documentSlaveAuthorsPanel.getSelectedItems()),
              this)).execute();
  }//GEN-LAST:event_deleteAuthorsButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteWordsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteWordsButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new DeleteWordsFromDocumentEdit(getMasterItem(),
            this.documentSlaveWordsPanel.getSelectedItems()), this)).execute();
  }//GEN-LAST:event_deleteWordsButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteReferencesButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteReferencesButtonActionPerformed

    (new PerformKnowledgeBaseEditTask(new DeleteReferencesFromDocumentEdit(getMasterItem(), 
            this.documentSlaveReferencesPanel.getSelectedItems()), 
            this)).execute();
  }//GEN-LAST:event_deleteReferencesButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteAffiliationsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteAffiliationsButtonActionPerformed

    (new PerformKnowledgeBaseEditTask(new DeleteAffiliationsFromDocumentEdit(getMasterItem(), 
            this.documentSlaveAffiliationsPanel.getSelectedItems()), 
            this)).execute();
  }//GEN-LAST:event_deleteAffiliationsButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void updateAuthorPositionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateAuthorPositionButtonActionPerformed
    
    EditDialogManager.getInstance().showUpdateDocumentAuthorPositionDialog(this.documentSlaveAuthorsPanel.getSelectedItems().get(0));
  }//GEN-LAST:event_updateAuthorPositionButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void updateWordRolButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateWordRolButtonActionPerformed
    
    EditDialogManager.getInstance().showUpdateDocumentWordRolDialog(this.documentSlaveWordsPanel.getSelectedItems().get(0));
  }//GEN-LAST:event_updateWordRolButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deletePublishDateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deletePublishDateButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new DeletePublishDateFromDocumentEdit(this.getMasterItem()),this)).execute();
  }//GEN-LAST:event_deletePublishDateButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void deleteJournalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deleteJournalButtonActionPerformed
    
    (new PerformKnowledgeBaseEditTask(new DeleteJournalFromDocumentEdit(this.getMasterItem()),this)).execute();
  }//GEN-LAST:event_deleteJournalButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addJournalButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addJournalButtonActionPerformed
    
    try {
    
      DocumentDAO documentDAO = CurrentProject.getInstance().getFactoryDAO().getDocumentDAO();
      JournalDAO journalDAO = CurrentProject.getInstance().getFactoryDAO().getJournalDAO();
      
      Journal journal = documentDAO.getJournal(getMasterItem().getDocumentID());
      TreeSet<Journal> journals = new TreeSet<Journal>(journalDAO.getJournals());
      
      if (journal != null) {
      
        journals.remove(journal);
      }
      
      AddDialogManager.getInstance().showAddJournalToDocumentDialog(getMasterItem(), new ArrayList<Journal>(journals));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addJournalButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addPublishDateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addPublishDateButtonActionPerformed
    
    try {
    
      DocumentDAO documentDAO = CurrentProject.getInstance().getFactoryDAO().getDocumentDAO();
      PublishDateDAO publishDateDAO = CurrentProject.getInstance().getFactoryDAO().getPublishDateDAO();
      
      PublishDate publishDate = documentDAO.getPublishDate(getMasterItem().getDocumentID());
      TreeSet<PublishDate> publishDates = new TreeSet<PublishDate>(publishDateDAO.getPublishDates());
      
      if (publishDate != null) {
      
        publishDates.remove(publishDate);
      }
      
      AddDialogManager.getInstance().showAddPublishDateToDocumentDialog(getMasterItem(), new ArrayList<PublishDate>(publishDates));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addPublishDateButtonActionPerformed

  /**
   * 
   * @param evt 
   */
  private void addAuthorButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAuthorButtonActionPerformed
    
    try {
    
      DocumentDAO documentDAO = CurrentProject.getInstance().getFactoryDAO().getDocumentDAO();
      AuthorDAO authorDAO = CurrentProject.getInstance().getFactoryDAO().getAuthorDAO();
      
      ArrayList<Author> authorsInDocument = documentDAO.getAuthors(getMasterItem().getDocumentID());
      TreeSet<Author> possibleAuthors = new TreeSet<Author>(authorDAO.getAuthors());
      
      possibleAuthors.removeAll(authorsInDocument);
      
      AddDialogManager.getInstance().showAddAuthorsToDocumentDialog(getMasterItem(), new ArrayList<Author>(possibleAuthors));
      
    } catch (KnowledgeBaseException e) {
    
      ErrorDialogManager.getInstance().showException(e);
    }
  }//GEN-LAST:event_addAuthorButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton addAffiliationButton;
  private javax.swing.JButton addAuthorButton;
  private javax.swing.JButton addJournalButton;
  private javax.swing.JButton addPublishDateButton;
  private javax.swing.JButton addReferenceButton;
  private javax.swing.JButton addWordButton;
  private javax.swing.JPanel affiliationsInfoPanel;
  private javax.swing.JPanel authorsInfoPanel;
  private scimat.gui.components.SelectionObserverButton deleteAffiliationsButton;
  private scimat.gui.components.SelectionObserverButton deleteAuthorsButton;
  private scimat.gui.components.SlaveItemObserverButton deleteJournalButton;
  private scimat.gui.components.SlaveItemObserverButton deletePublishDateButton;
  private scimat.gui.components.SelectionObserverButton deleteReferencesButton;
  private scimat.gui.components.SelectionObserverButton deleteWordsButton;
  private scimat.gui.components.detailspanel.DocumentDetailPanel documentDetailPanel;
  private javax.swing.JPanel documentInfoPanel;
  private scimat.gui.components.slavepanel.DocumentSlaveAffiliationsPanel documentSlaveAffiliationsPanel;
  private scimat.gui.components.slavepanel.DocumentSlaveAuthorsPanel documentSlaveAuthorsPanel;
  private scimat.gui.components.slavepanel.DocumentSlaveJournalPanel documentSlaveJournalPanel;
  private scimat.gui.components.slavepanel.DocumentSlavePublishDatePanel documentSlavePublishDatePanel;
  private scimat.gui.components.slavepanel.DocumentSlaveReferencesPanel documentSlaveReferencesPanel;
  private scimat.gui.components.slavepanel.DocumentSlaveWordsPanel documentSlaveWordsPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAffiliationPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowAuthorPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowDocumentPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowJournalPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowPublishDatePanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferencePanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowWordPanel;
  private javax.swing.JPanel journalInfoPanel;
  private javax.swing.JPanel publishDateInfoPanel;
  private javax.swing.JPanel referencesInfoPanel;
  private scimat.gui.components.SelectionObserverButton updateAuthorPositionButton;
  private javax.swing.JButton updateDocumentButton;
  private scimat.gui.components.SelectionObserverButton updateWordRolButton;
  private javax.swing.JPanel wordsInfoPanel;
  // End of variables declaration//GEN-END:variables
}
