/*
 * ReferenceGroupGlobalSlavePanel.java
 *
 * Created on 13-mar-2011, 17:12:47
 */
package scimat.gui.components.globalslavepanel;

import javax.swing.JOptionPane;
import scimat.gui.commands.edit.update.UpdateReferenceGroupEdit;
import scimat.gui.commands.task.PerformKnowledgeBaseEditTask;
import scimat.model.knowledgebase.entity.ReferenceGroup;

/**
 *
 * @author mjcobo
 */
public class ReferenceGroupGlobalSlavePanel extends GlobalSlavePanel<ReferenceGroup> {

  /** Creates new form ReferenceGroupGlobalSlavePanel */
  public ReferenceGroupGlobalSlavePanel() {
    initComponents();
  }

  @Override
  public void refresh(ReferenceGroup item) {

    setMasterItem(item);

    this.referenceGroupDetailPanel.refreshItem(item);
    this.referenceGroupSlaveReferencesPanel.setMasterItem(item);

    if (item != null) {
      
      this.updateReferenceGroupButton.setEnabled(true);

    } else {
      
      this.updateReferenceGroupButton.setEnabled(false);

    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    hideAndShowReferenceGroupPanel = new scimat.gui.components.HideAndShowPanel();
    referenceGroupInfoPanel = new javax.swing.JPanel();
    updateReferenceGroupButton = new javax.swing.JButton();
    referenceGroupDetailPanel = new scimat.gui.components.detailspanel.ReferenceGroupDetailPanel();
    hideAndShowReferencePanel = new scimat.gui.components.HideAndShowPanel();
    referenceInfoPanel = new javax.swing.JPanel();
    referenceGroupSlaveReferencesPanel = new scimat.gui.components.slavepanel.ReferenceGroupSlaveReferencesPanel();

    this.hideAndShowReferenceGroupPanel.setDescription("Reference group");
    this.hideAndShowReferenceGroupPanel.setPanel(this.referenceGroupInfoPanel);

    updateReferenceGroupButton.setText("Update");
    updateReferenceGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        updateReferenceGroupButtonActionPerformed(evt);
      }
    });

    javax.swing.GroupLayout referenceGroupInfoPanelLayout = new javax.swing.GroupLayout(referenceGroupInfoPanel);
    referenceGroupInfoPanel.setLayout(referenceGroupInfoPanelLayout);
    referenceGroupInfoPanelLayout.setHorizontalGroup(
      referenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceGroupInfoPanelLayout.createSequentialGroup()
        .addContainerGap(313, Short.MAX_VALUE)
        .addComponent(updateReferenceGroupButton))
      .addComponent(referenceGroupDetailPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    referenceGroupInfoPanelLayout.setVerticalGroup(
      referenceGroupInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, referenceGroupInfoPanelLayout.createSequentialGroup()
        .addComponent(referenceGroupDetailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(updateReferenceGroupButton))
    );

    this.hideAndShowReferencePanel.setDescription("References info");
    this.hideAndShowReferencePanel.setPanel(this.referenceInfoPanel);

    javax.swing.GroupLayout referenceInfoPanelLayout = new javax.swing.GroupLayout(referenceInfoPanel);
    referenceInfoPanel.setLayout(referenceInfoPanelLayout);
    referenceInfoPanelLayout.setHorizontalGroup(
      referenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceGroupSlaveReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
    );
    referenceInfoPanelLayout.setVerticalGroup(
      referenceInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(referenceGroupSlaveReferencesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 149, Short.MAX_VALUE)
    );

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addContainerGap()
        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addComponent(referenceGroupInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowReferenceGroupPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE)
          .addComponent(referenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 380, Short.MAX_VALUE))
        .addContainerGap())
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(hideAndShowReferenceGroupPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceGroupInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(hideAndShowReferencePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(referenceInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addContainerGap())
    );
  }// </editor-fold>//GEN-END:initComponents

  /**
   * 
   * @param evt
   */
  private void updateReferenceGroupButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_updateReferenceGroupButtonActionPerformed

    PerformKnowledgeBaseEditTask task;

    // If the name is empty
    if (this.referenceGroupDetailPanel.getGroupName().isEmpty()) {

      JOptionPane.showMessageDialog(this, "You have to give a group name.\nPlease, " +
        "give a name for the group.", "Invalid group name", JOptionPane.ERROR_MESSAGE);

    } else {

      task = new PerformKnowledgeBaseEditTask(new UpdateReferenceGroupEdit(getMasterItem().getReferenceGroupID(),
              this.referenceGroupDetailPanel.getGroupName(),
              this.referenceGroupDetailPanel.isStopGroup()), this);

      task.execute();
    }
  }//GEN-LAST:event_updateReferenceGroupButtonActionPerformed

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private scimat.gui.components.HideAndShowPanel hideAndShowReferenceGroupPanel;
  private scimat.gui.components.HideAndShowPanel hideAndShowReferencePanel;
  private scimat.gui.components.detailspanel.ReferenceGroupDetailPanel referenceGroupDetailPanel;
  private javax.swing.JPanel referenceGroupInfoPanel;
  private scimat.gui.components.slavepanel.ReferenceGroupSlaveReferencesPanel referenceGroupSlaveReferencesPanel;
  private javax.swing.JPanel referenceInfoPanel;
  private javax.swing.JButton updateReferenceGroupButton;
  // End of variables declaration//GEN-END:variables
}
