/*
 * GenericSelectManyItemsPanel.java
 *
 * Created on 31-mar-2011, 23:31:16
 */
package scimat.gui.components.itemslist;

import java.util.ArrayList;
import scimat.gui.components.SelectionObserverButton;
import scimat.gui.components.observer.ElementsCountObserver;


/**
 *
 * @author mjcobo
 */
public class GenericSelectManyItemsPanel<E extends Comparable<E>> extends javax.swing.JPanel {

  /** 
   * Creates new form GenericSelectManyItemsPanel
   */
  public GenericSelectManyItemsPanel(GenericDynamicItemsListPanel<E> sourceListPanel, GenericDynamicItemsListPanel<E> targetListPanel) {

    this.sourceListPanel = sourceListPanel;
    this.targetListPanel = targetListPanel;

    initComponents();

    this.sourcePanel.add(this.sourceListPanel);
    this.targetPanel.add(this.targetListPanel);
  }

  /**
   * 
   * @param items
   */
  public void refreshData(ArrayList<E> items) {

    this.sourceListPanel.refreshItems(items);
    this.targetListPanel.refreshItems(new ArrayList<E>());
  }

  public ArrayList<E> getTargetItems() {

    return this.targetListPanel.getItems();
  }
  
  /**
   * 
   * @param items 
   */
  public void addNewTargetItems(ArrayList<E> items) {
    
    this.targetListPanel.addItems(items);
  }

  /**
   *
   * @param observer
   */
  public void addTargetElementsCountObserver(ElementsCountObserver observer) {

    this.targetListPanel.addElementsCountObserver(observer);
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        sourcePanel = new javax.swing.JPanel();
        targetPanel = new javax.swing.JPanel();
        flowRightButton = new SelectionObserverButton(1, -1);
        flowLeftButton = new SelectionObserverButton(1, -1);

        sourcePanel.setLayout(new javax.swing.BoxLayout(sourcePanel, javax.swing.BoxLayout.LINE_AXIS));

        targetPanel.setLayout(new javax.swing.BoxLayout(targetPanel, javax.swing.BoxLayout.LINE_AXIS));

        flowRightButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/next24x24.png"))); // NOI18N
        flowRightButton.setText("");
        flowRightButton.setEnabled(false);
        this.sourceListPanel.addSelectionObserver(flowRightButton);
        flowRightButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                flowRightButtonActionPerformed(evt);
            }
        });

        flowLeftButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/back24x24.png"))); // NOI18N
        flowLeftButton.setText("");
        flowLeftButton.setEnabled(false);
        this.targetListPanel.addSelectionObserver(this.flowLeftButton);
        flowLeftButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                flowLeftButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(sourcePanel, javax.swing.GroupLayout.DEFAULT_SIZE, 126, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(flowLeftButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(flowRightButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(targetPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 126, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(sourcePanel, javax.swing.GroupLayout.Alignment.CENTER, javax.swing.GroupLayout.DEFAULT_SIZE, 218, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.CENTER, layout.createSequentialGroup()
                .addComponent(flowRightButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(flowLeftButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addComponent(targetPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 218, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

  /**
   *
   * @param evt
   */
  private void flowRightButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flowRightButtonActionPerformed

    this.targetListPanel.addItems(this.sourceListPanel.getSelectedItems());
    this.sourceListPanel.removeItems(this.sourceListPanel.getSelectedItems());
  }//GEN-LAST:event_flowRightButtonActionPerformed

  /**
   *
   * @param evt
   */
  private void flowLeftButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_flowLeftButtonActionPerformed

    this.sourceListPanel.addItems(this.targetListPanel.getSelectedItems());
    this.targetListPanel.removeItems(this.targetListPanel.getSelectedItems());
  }//GEN-LAST:event_flowLeftButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private scimat.gui.components.SelectionObserverButton flowLeftButton;
    private scimat.gui.components.SelectionObserverButton flowRightButton;
    private javax.swing.JPanel sourcePanel;
    private javax.swing.JPanel targetPanel;
    // End of variables declaration//GEN-END:variables
  private GenericDynamicItemsListPanel<E> sourceListPanel;
  private GenericDynamicItemsListPanel<E> targetListPanel;
}
