/*
 * SelectLongitudinalMeasuresPanel.java
 *
 * Created on 09-may-2011, 17:10:15
 */
package scimat.gui.components.wizard.Analysis;

import scimat.analysis.SimilarityMeasuresEnum;
import scimat.gui.components.IncorrectDataObserver;
import scimat.gui.components.wizard.GenericWizardStepPanel;

/**
 *
 * @author mjcobo
 */
public class SelectLongitudinalMeasuresPanel extends GenericWizardStepPanel {

  /** Creates new form SelectLongitudinalMeasuresPanel */
  public SelectLongitudinalMeasuresPanel() {
    initComponents();

    this.evolutionMapMeasuresPanel.addIncorrectDataObserver(new IncorrectDataObserver() {

      public void incorrectData(boolean correct, String message) {
        evolutionMapMeasureSelected = correct;

        fireIncorrectDataObservers();
      }
    });

    this.overlappingMapMeasuresPanel.addIncorrectDataObserver(new IncorrectDataObserver() {

      public void incorrectData(boolean correct, String message) {
        overlappingMapMeasureSelected = correct;

        fireIncorrectDataObservers();
      }
    });
  }

  /**
   * 
   */
  @Override
  public void refresh() {
    this.evolutionMapMeasuresPanel.refresh();
    this.overlappingMapMeasuresPanel.refresh();

    this.evolutionMapMeasureSelected = false;
    this.overlappingMapMeasureSelected = false;

    fireIncorrectDataObservers();
  }

  /**
   * 
   */
  @Override
  public void fireIncorrectDataObservers() {

    if (this.evolutionMapMeasureSelected && this.overlappingMapMeasureSelected) {

      notifyIncorrectDataObservers(true, "");

    } else {

      notifyIncorrectDataObservers(false, "A similarity measure must be selected for both maps.");
    }
  }

  /**
   *
   * @return
   */
  public SimilarityMeasuresEnum getSelectedEvolutionMapMeasures() {

    return this.evolutionMapMeasuresPanel.getSelectedNormalizationMeasures();
  }

  /**
   * 
   * @return
   */
  public SimilarityMeasuresEnum getSelectedOverlappingMapMeasures() {

    return this.overlappingMapMeasuresPanel.getSelectedNormalizationMeasures();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    evolutionMapMeasuresPanel = new scimat.gui.components.wizard.Analysis.SelectSimilarityMeasurePanel();
    overlappingMapMeasuresPanel = new scimat.gui.components.wizard.Analysis.SelectSimilarityMeasurePanel();

    evolutionMapMeasuresPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Evolution map"));

    overlappingMapMeasuresPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Overlapping map"));

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(layout.createSequentialGroup()
        .addComponent(evolutionMapMeasuresPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(overlappingMapMeasuresPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(evolutionMapMeasuresPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
      .addComponent(overlappingMapMeasuresPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
    );
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private scimat.gui.components.wizard.Analysis.SelectSimilarityMeasurePanel evolutionMapMeasuresPanel;
  private scimat.gui.components.wizard.Analysis.SelectSimilarityMeasurePanel overlappingMapMeasuresPanel;
  // End of variables declaration//GEN-END:variables
  private boolean evolutionMapMeasureSelected;
  private boolean overlappingMapMeasureSelected;
}
