/*
 * GenericWizardStepPanel.java
 *
 * Created on 02-abr-2011, 17:35:44
 */
package scimat.gui.components.wizard;

import java.util.ArrayList;
import scimat.gui.components.IncorrectDataObserver;

/**
 *
 * @author mjcobo
 */
public abstract class GenericWizardStepPanel extends javax.swing.JPanel {

  /** Creates new form GenericWizardStepPanel */
  public GenericWizardStepPanel() {
    initComponents();
  }

  /**
   * Añade un nuevo observador de datos incorrectos.
   *
   * @param observer observador a añadir.
   */
  public void addIncorrectDataObserver(IncorrectDataObserver observer) {
    incorrectDataObservers.add(observer);
    fireIncorrectDataObservers();
  }

  /**
   * 
   */
  public abstract void refresh();

  /**
   *
   */
  public abstract void fireIncorrectDataObservers();

  /**
   *
   */
  public void notifyIncorrectDataObservers(boolean correct, String message){

    for (int i = 0; i < incorrectDataObservers.size(); i++) {

      incorrectDataObservers.get(i).incorrectData(correct, message);
    }
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
    this.setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGap(0, 303, Short.MAX_VALUE)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGap(0, 170, Short.MAX_VALUE)
    );
  }// </editor-fold>//GEN-END:initComponents
  // Variables declaration - do not modify//GEN-BEGIN:variables
  // End of variables declaration//GEN-END:variables
  private ArrayList<IncorrectDataObserver> incorrectDataObservers = new ArrayList<IncorrectDataObserver>();
}
